<?xml version='1.0'?>
<!DOCTYPE doc SYSTEM "../../lib/xml/xsl.dtd" >
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0" xmlns:xs="http://www.w3.org/2001/XMLSchema" exclude-result-prefixes="xs">
 <!-- Map a P, Q document per Algorithm O http://lists.w3.org/Archives/Public/www-xml-schema-comments/2011JanMar/att-0170/override_fix.html -->
 <xsl:output method="xml" indent="yes"/>
 
 <xsl:param name="debug">0</xsl:param>
 
 <xsl:template match="o">
  <xsl:copy>
   <xsl:call-template name="step_3">
    <xsl:with-param name="i" select="count(p/*)+count(q/*)"/>
   </xsl:call-template>
  </xsl:copy>
  <xsl:text>&#10;</xsl:text>
 </xsl:template>
 
 <xsl:template name="step_3">
  <xsl:param name="i"/>
  <xsl:choose>
   <xsl:when test="q/*">
    <xsl:call-template name="step_4n5">
     <xsl:with-param name="i" select="$i"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <!-- Queue is empty, no-op -->
    <xsl:apply-templates mode="copy" select="node()|@*"/>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
 
 <xsl:template name="step_4n5">
  <xsl:param name="i"/>
  <xsl:variable name="n" select="q/sd[1]"/>
  <xsl:choose>
   <xsl:when test="some $m in p/* satisfies
                      ($m/@uri=$n/@uri and
                       (some $mm in $m/* satisfies 
                          (some $nm in $n/* satisfies 
                            ($mm/@name = $nm/@name and
                             $mm/@type = $nm/@type and
                             not($mm/@uri = $nm/@uri and $mm/@pos = $nm/@pos)
                            )
                           )
                        )
                       )">
    <xsl:message terminate="yes">Losing: </xsl:message>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="step_6">
     <xsl:with-param name="i" select="$i"/>
     <xsl:with-param name="n" select="$n"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
 
 <xsl:template name="step_6">
  <xsl:param name="i"/>
  <xsl:param name="n"/>
  <xsl:choose>
   <xsl:when test="some $m in p/* satisfies
                    ($m/@uri = $n/@uri and
                     (every $nm in $n/* satisfies 
                       (some $mm in $m/* satisfies
                         ($nm/@name = $mm/@name and
                          $nm/@type = $mm/@type and
                          $nm/@uri = $mm/@uri and
                          $nm/@pos = $mm/@pos)
                       )
                     )
                    )">
    <p>
     <xsl:if test="not($debug='0')"><xsl:message>Subset: <xsl:value-of select="$n/@i"/></xsl:message></xsl:if>
     <xsl:apply-templates select="p/*" mode="copy"/>     
    </p>
    <q>
     <xsl:apply-templates select="q/sd[position()>1]" mode="copy"/>
    </q>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="step_7">
     <xsl:with-param name="i" select="$i"/>
     <xsl:with-param name="n" select="$n"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>  
 </xsl:template>
 
 <xsl:template name="step_7">
  <xsl:param name="i"/>
  <xsl:param name="n"/>
  <p>
     <xsl:apply-templates select="p/*" mode="copy"/>     
   <xsl:copy-of select="$n"/>
    </p>
  <xsl:variable name="oo" select="doc($n/@uri)/xs:schema/xs:override"/>
  <q>
   <xsl:apply-templates select="q/sd[position()>1]" mode="copy"/>
   <xsl:for-each select="$oo">
    <sd uri="{@schemaLocation}" i="{$i+position()}" parent="{$n/@i}">
     <xsl:apply-templates select="$n/m" mode="copy"/>
     <xsl:apply-templates>
      <xsl:with-param name="uri" select="$n/@uri"/>
      <xsl:with-param name="pos" select="position()"/>
      <xsl:with-param name="incoming" select="$n/m"/>
     </xsl:apply-templates>
    </sd>
  </xsl:for-each>
  </q>
 </xsl:template>
 
 <xsl:template match="xs:element|xs:complexType|xs:simpleType">
  <xsl:param name="uri"/>
  <xsl:param name="pos"/>
  <xsl:param name="incoming"/>
  <xsl:variable name="name" select="@name"/>
  <xsl:variable name="type" select="local-name()"/>
  <xsl:if test="not(some $m in $incoming satisfies
                         ($m/@name=$name and $m/@type=$type))">
   <m name="{$name}" type="{$type}" uri="{$uri}" pos="{$pos}"/>
  </xsl:if>
 </xsl:template>
 
 <xsl:template match="node()|@*" mode="copy">
  <xsl:copy>
   <xsl:apply-templates mode="copy" select="node()|@*"/>
  </xsl:copy>
 </xsl:template>
</xsl:stylesheet>
